/*
  Patchobjekt, ein grafisches Objekt das alle mglichen
  Formen darstellen kann.
  
  Definition in ray.H


  Noch ungetestet, unimplementiert ...

  Problem:
    Verdeckung des eigenen Krpers gegenber der Lichtquellen beim
    Raytracing.

  ev. Lsung:
    Patchobjekt nicht in die Objekteliste des Raytracers einfgen,
    neues Objekt z.B. Patchpoly einfhren welches fr jedes Patch
    einmal erzeugt wird, dieses wird in die Objektliste des Raytracers
    eingefgt und zeigt auf sein Objekt in der patchobj Klasse auf 
    die Daten und Funktionen.

   Dieses Modul steht nicht unter der GPL. Alle Urheberrechte und das
   Kopierrecht gehren Helmut Fahrion.

   Der Quellcode dieses Modules wird im Quellcode ausgeliefert um das
   Portieren dieser Software zu ermglichen.

   Dieses Modul darf fr andere Zwecke nicht verwendet werden.

   Wer dieses Modul fr Zwecke der Weiterentwicklung oder fr ein
   eigenes Produkt bentigt mu sich mit mir in Verbindung setzen.

   email:
     hf@suse.de
   oder
     nazca@informatik.htw-dresden.de

  Copyright (C) 1997 Helmut Fahrion
*/


#include "ray.H"

// Dummyfunktion da dieses Objekt noch nicht als Schnittkrper 
// verwendet werden kann.
bool patchobj::in_obj(vector mp)
{
  return true;
}

// Treffpunkt
bool patchobj::hit_object(vector point, vector dir, bool hitin,
			  vector * int_pt1, vector * norm1,
			  vector * int_pt2, vector * norm2)
{
  return pp->get_patch_int(point, dir, int_pt1, norm1, int_pt2, norm2);
}

// Texture auftragen
void patchobj::surfaceCol(color * col, vector intpoint, cover * cp, byte art)
{
  // ### noch implementieren ###
  *col = color(1,0,0);
}

void patchobj::setpatch(vector m, vector n)
{
  if (pla)
    pl = new patchinitl(pl, m, n);
  else
    pla = pl = new patchinitl(pl, m, n);
}

patcharray *patchobj::createpatch(float Min, bool Schn, obj * grobj)
{
  if (pp) return pp;

  pp = new patcharray(Min, Schn, grobj, pla);

  delete pla; pla=NULL;

  return pp;
}

bool patchobj::testgrobj(vector * p1, vector * p2, vector nv1, vector nv2)
{
  longint px;
  float   r;
  vector  pt1, pt2;

  r   = pp->r;
  pt1 = pt2 = pp->pa[0].m;  // init

  // suche kleinsten und grten
  for (px=0; px < pp->anz; px++)
    {
      if (abs(pp->pa[px].m) < abs(pt1)) pt1 = pp->pa[px].m;
      if (abs(pp->pa[px].m) > abs(pt2)) pt2 = pp->pa[px].m;
    }

  *p1 = pt1 - vector(r, r, r);
  *p2 = pt2 + vector(r, r, r);

  // Test ob reinpasst
  if ((nv1.x <= p1->x && nv1.y <= p1->y && nv1.z <= p1->z) &&
      (nv2.x >= p2->x && nv2.y >= p2->y && nv2.z >= p2->z))
    return true;
  else
    return false;
}

bool patchobj::getpoints(vector * v1, longint x)
{
  if (x >= 1)
    {
      if (x-1 < pp->anz)
	{
	  *v1 = pp->pa[x].m;
	  return true;
	}
    }
  return false;
}










